assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")

local healthstoneicon = "Interface\\Icons\\INV_Stone_04"
local istrading = nil
local accepttrade = nil
local hashealthstone = nil
local healthstonebag = nil
local healthstoneslot = nil
local lastid = nil

local healthstoneid = {
	[5512] = true,
	[19004] = true,
	[19005] = true,
	[5511] = true,
	[19006] = true,
	[19007] = true,
	[5509] = true,
	[19008] = true,
	[19009] = true,
	[5510] = true,
	[19010] = true,
	[19011] = true,
	[9421] = true,
	[19012] = true,
	[19013] = true,
	[22103] = true,
	[22104] = true,
	[22105] = true,
}

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconHealthstone = Necronomicon:NewModule("Healthstone")
NecronomiconHealthstone.name = "Healthstone"

NecronomiconHealthstone.revision = tonumber(string.sub("$Revision: 27266 $", 12, -3))

NecronomiconHealthstone.defaults = {
	posx = 232,
	posy = 232,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconHealthstone:OnRegister()
	self:RegisterSpell("Create Healthstone")
	for k, v in pairs( healthstoneid ) do
		self:RegisterItem( k )
	end
end

function NecronomiconHealthstone:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:RegisterEvent("Necronomicon_BagUpdate")
	self:RegisterEvent("TRADE_SHOW")
	self:RegisterEvent("TRADE_REQUEST", "TRADE_SHOW")
	self:RegisterEvent("TRADE_CLOSED")
	self:RegisterEvent("TRADE_REQUEST_CANCEL", "TRADE_CLOSED")
	self:RegisterEvent("TRADE_ACCEPT_UPDATE")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconHealthstone:Necronomicon_SpellsUpdated()
	local spell = self:HasSpell("Create Healthstone")
	if spell then
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spell.id, BOOKTYPE_SPELL) ) )
		self.button.background:SetDesaturated(true)
		self.button:Show()
		self:Necronomicon_BagUpdate()
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:SetAttribute("item1", "")
		self.button:Hide()	
	end
end

function NecronomiconHealthstone:TRADE_SHOW()
	istrading = true
end

function NecronomiconHealthstone:TRADE_CLOSED()
	istrading = nil
end

function NecronomiconHealthstone:TRADE_ACCEPT_UPDATE()
	if istrading and accepttrade then
		AcceptTrade()
		istrading = nil
		accepttrade = nil
	end
end

function NecronomiconHealthstone:Necronomicon_BagUpdate()
	local item, name
	for k, v in pairs( healthstoneid ) do
		item = self:GetItem(k)
		if item then
			name = (GetItemInfo(GetContainerItemLink( item.bag, item.slot )))
			self.button:SetAttribute("type2", "TradeHealthstone")
			self.button:SetAttribute("type1", "item")
			self.button:SetAttribute("item1", name)
			self.button.background:SetDesaturated(false)
			break
		end
	end
	if not item then
		self.button.background:SetDesaturated(true)
		self.button:SetAttribute("type1", "spell")
	end
end

----------------------------------
--       Command Handlers       --
----------------------------------

function NecronomiconHealthstone:TradeHealthstone()
	local item

	for k, v in pairs( healthstoneid ) do
		item = self:GetItem(k)
		if item then
			break
		end
	end

	if item then
		if istrading and not accepttrade then
			PickupContainerItem( item.bag, item.slot)
			ClickTradeButton(1)
			accepttrade = true
		elseif UnitExists("target") and UnitIsPlayer("target") and UnitIsFriend("player","target") then
			PickupContainerItem( item.bag, item.slot)
			if CursorHasItem() then
				DropItemOnUnit("target")
				accepttrade = true
			end
		end
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconHealthstone:SetupButton()
	self:CreateButton()

	self.button.background:SetTexture( healthstoneicon )
	self.button.TradeHealthstone = function() self:TradeHealthstone() end
end
