assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local BS = AceLibrary("Babble-Spell-2.2")
local impicon = BS:GetSpellIcon("Summon Imp")

local spells = {
	["Summon Imp"] = true,
	["Summon Voildwalker"] = true,
	["Summon Succubus"] = true,
	["Summon Felhunter"] = true,
	["Summon Felguard"] = true,
	["Enslave Demon"] = true,
	["Fel Domination"] = true,
	["Demonic Sacrifice"] = true,
	["Soul Link"] = true,
	["Inferno"] = true,
	["Ritual of Doom"] = true,
}

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconMinion = Necronomicon:NewModule("Minion")

NecronomiconMinion.revision = tonumber(string.sub("$Revision: 26943 $", 12, -3))

NecronomiconMinion.defaults = {
	posx = 200,
	posy = 264,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconMinion:OnRegister()
	for k, v in pairs(spells) do
		self:RegisterSpell(k)
	end
end

function NecronomiconMinion:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconMinion:Necronomicon_SpellsUpdated()
end


----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconMinion:SetupButton()
	self:CreateButton("header")

	self.button.background:SetTexture( impicon )
end
